// Code generated by go-swagger; DO NOT EDIT.

package boundary_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-boundary-service/stable/2021-12-21/models"
	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
)

// BoundaryServiceCreateReader is a Reader for the BoundaryServiceCreate structure.
type BoundaryServiceCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *BoundaryServiceCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewBoundaryServiceCreateOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewBoundaryServiceCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewBoundaryServiceCreateOK creates a BoundaryServiceCreateOK with default headers values
func NewBoundaryServiceCreateOK() *BoundaryServiceCreateOK {
	return &BoundaryServiceCreateOK{}
}

/*
BoundaryServiceCreateOK describes a response with status code 200, with default header values.

A successful response.
*/
type BoundaryServiceCreateOK struct {
	Payload *models.HashicorpCloudBoundary20211221CreateResponse
}

// IsSuccess returns true when this boundary service create o k response has a 2xx status code
func (o *BoundaryServiceCreateOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this boundary service create o k response has a 3xx status code
func (o *BoundaryServiceCreateOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this boundary service create o k response has a 4xx status code
func (o *BoundaryServiceCreateOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this boundary service create o k response has a 5xx status code
func (o *BoundaryServiceCreateOK) IsServerError() bool {
	return false
}

// IsCode returns true when this boundary service create o k response a status code equal to that given
func (o *BoundaryServiceCreateOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the boundary service create o k response
func (o *BoundaryServiceCreateOK) Code() int {
	return 200
}

func (o *BoundaryServiceCreateOK) Error() string {
	return fmt.Sprintf("[POST /boundary/2021-12-21/organizations/{location.organization_id}/projects/{location.project_id}/clusters][%d] boundaryServiceCreateOK  %+v", 200, o.Payload)
}

func (o *BoundaryServiceCreateOK) String() string {
	return fmt.Sprintf("[POST /boundary/2021-12-21/organizations/{location.organization_id}/projects/{location.project_id}/clusters][%d] boundaryServiceCreateOK  %+v", 200, o.Payload)
}

func (o *BoundaryServiceCreateOK) GetPayload() *models.HashicorpCloudBoundary20211221CreateResponse {
	return o.Payload
}

func (o *BoundaryServiceCreateOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.HashicorpCloudBoundary20211221CreateResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewBoundaryServiceCreateDefault creates a BoundaryServiceCreateDefault with default headers values
func NewBoundaryServiceCreateDefault(code int) *BoundaryServiceCreateDefault {
	return &BoundaryServiceCreateDefault{
		_statusCode: code,
	}
}

/*
BoundaryServiceCreateDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type BoundaryServiceCreateDefault struct {
	_statusCode int

	Payload *cloud.GrpcGatewayRuntimeError
}

// IsSuccess returns true when this boundary service create default response has a 2xx status code
func (o *BoundaryServiceCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this boundary service create default response has a 3xx status code
func (o *BoundaryServiceCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this boundary service create default response has a 4xx status code
func (o *BoundaryServiceCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this boundary service create default response has a 5xx status code
func (o *BoundaryServiceCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this boundary service create default response a status code equal to that given
func (o *BoundaryServiceCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the boundary service create default response
func (o *BoundaryServiceCreateDefault) Code() int {
	return o._statusCode
}

func (o *BoundaryServiceCreateDefault) Error() string {
	return fmt.Sprintf("[POST /boundary/2021-12-21/organizations/{location.organization_id}/projects/{location.project_id}/clusters][%d] BoundaryService_Create default  %+v", o._statusCode, o.Payload)
}

func (o *BoundaryServiceCreateDefault) String() string {
	return fmt.Sprintf("[POST /boundary/2021-12-21/organizations/{location.organization_id}/projects/{location.project_id}/clusters][%d] BoundaryService_Create default  %+v", o._statusCode, o.Payload)
}

func (o *BoundaryServiceCreateDefault) GetPayload() *cloud.GrpcGatewayRuntimeError {
	return o.Payload
}

func (o *BoundaryServiceCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(cloud.GrpcGatewayRuntimeError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
