// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUpsertSyncInstallationParams creates a new UpsertSyncInstallationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpsertSyncInstallationParams() *UpsertSyncInstallationParams {
	return &UpsertSyncInstallationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpsertSyncInstallationParamsWithTimeout creates a new UpsertSyncInstallationParams object
// with the ability to set a timeout on a request.
func NewUpsertSyncInstallationParamsWithTimeout(timeout time.Duration) *UpsertSyncInstallationParams {
	return &UpsertSyncInstallationParams{
		timeout: timeout,
	}
}

// NewUpsertSyncInstallationParamsWithContext creates a new UpsertSyncInstallationParams object
// with the ability to set a context for a request.
func NewUpsertSyncInstallationParamsWithContext(ctx context.Context) *UpsertSyncInstallationParams {
	return &UpsertSyncInstallationParams{
		Context: ctx,
	}
}

// NewUpsertSyncInstallationParamsWithHTTPClient creates a new UpsertSyncInstallationParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpsertSyncInstallationParamsWithHTTPClient(client *http.Client) *UpsertSyncInstallationParams {
	return &UpsertSyncInstallationParams{
		HTTPClient: client,
	}
}

/*
UpsertSyncInstallationParams contains all the parameters to send to the API endpoint

	for the upsert sync installation operation.

	Typically these are written to a http.Request.
*/
type UpsertSyncInstallationParams struct {

	// Body.
	Body UpsertSyncInstallationBody

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the upsert sync installation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpsertSyncInstallationParams) WithDefaults() *UpsertSyncInstallationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the upsert sync installation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpsertSyncInstallationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the upsert sync installation params
func (o *UpsertSyncInstallationParams) WithTimeout(timeout time.Duration) *UpsertSyncInstallationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the upsert sync installation params
func (o *UpsertSyncInstallationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the upsert sync installation params
func (o *UpsertSyncInstallationParams) WithContext(ctx context.Context) *UpsertSyncInstallationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the upsert sync installation params
func (o *UpsertSyncInstallationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the upsert sync installation params
func (o *UpsertSyncInstallationParams) WithHTTPClient(client *http.Client) *UpsertSyncInstallationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the upsert sync installation params
func (o *UpsertSyncInstallationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the upsert sync installation params
func (o *UpsertSyncInstallationParams) WithBody(body UpsertSyncInstallationBody) *UpsertSyncInstallationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the upsert sync installation params
func (o *UpsertSyncInstallationParams) SetBody(body UpsertSyncInstallationBody) {
	o.Body = body
}

// WithOrganizationID adds the organizationID to the upsert sync installation params
func (o *UpsertSyncInstallationParams) WithOrganizationID(organizationID string) *UpsertSyncInstallationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the upsert sync installation params
func (o *UpsertSyncInstallationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the upsert sync installation params
func (o *UpsertSyncInstallationParams) WithProjectID(projectID string) *UpsertSyncInstallationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the upsert sync installation params
func (o *UpsertSyncInstallationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *UpsertSyncInstallationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
